package bot

import (
        "discord-cfb-bot/config"
        cfbClient "git.ewnix.net/phlux/discord-cfb-bot/internal/clients/cfb"
	cbbClient "git.ewnix.net/discord-cfb-bot/internal/clients/cbb"
        "github.com/bwmarrin/discordgo"
        "fmt"
        "strings"
)

var Bot *discordgo.Session

func Start() error {
        var err error
        Bot, err = discordgo.New("Bot " + config.BotToken)
        if err != nil {
                return fmt.Errorf("error creating a Discord session: %w", err)
        }

        fmt.Println("Discord session created successfully")

        Bot.AddHandler(commandHandler)
        err = Bot.Open()
        if err != nil {
                return fmt.Errorf("Error opening connection: %w", err)
        }
        fmt.Println("Bot is now running.")
        return nil
}

func commandHandler(s *discordgo.Session, m *discordgo.MessageCreate) {
        if m.Author.Bot {
                return
        }

        if strings.HasPrefix(m.Content, "!cfb ") {
                teamName := strings.TrimSpace(strings.TrimPrefix(m.Content, "!cfb "))
                response := cfbClient.GetGameInfo(teamName)
                s.ChannelMessageSend(m.ChannelID, response)
        }

	if strings.HasPrefix(m.Content, "!cbb ") {
		teamName := strings.TrimSpace(strings.TrimPrefix(m.Content, "!cbb "))
		response := cbbClient.GetGameInfo(teamName)
		s.ChannelMessageSend(m.ChannelID, response)
	}
}
